/***************************************************************************
                          testsuite.c  -  description
                             -------------------
    begin                : Tue Dec 28 1999
    copyright            : (C) 1999 by Eugene S. Weiss
    email                : eweiss@sas.upenn.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "as6edriver.h"
#include "regdata.h"
#include "prototypes.h"
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <linux/ppdev.h>
#include <sys/io.h>
#include <linux/parport.h>


void testsuite(int port)
{
    int testno;

    while (testno != 99) {
	printf("\nEnter the number of the test you wish to run: ");
	scanf("%d", &testno);
//              if (testno == 0) test0(port);
	if (testno == 1)
	    test1(port);
	if (testno == 2)
	    test2(port);
	if (testno == 3)
	    test3(port);
	if (testno == 4)
	    test4(port);
	if (testno == 5)
	    test5(port);
	if (testno == 6)
	    test6(port);
	if (testno == 7)
	    test7(port);
	if (testno == 8)
	    test8(port);
	if (testno == 9)
	    test9(port);
	if (testno == 10)
	    scan(port, DPI50, COLOR, 0, 100, 0, 1000);
	if (testno == 11)
	    test11(port);
	if (testno == 12)
	    test12(port);
	if (testno == 13)
	    test13(port);
	if (testno == 14)
	    test14(port);
    }
}








void test14(int port)
{
    int regno, intdata;
    unsigned short data;

    while (regno != 99) {
	printf("\nEnter the number of the register: ");
	scanf("%d", &regno);
	printf("\nYou entered %d", regno);

	printf("\nEnter a number for the selected register: ");
	scanf("%04x", &intdata);
	data = intdata;
	printf("\nYou entered 0x%04x", data);

	write_register(port, regno, data);
    }
}


void test13(int port)
{
    int value;
    unsigned char val;

    printf("\nEnter a value for threshold low: ");
    scanf("%04x", &value);
    val = value;
    printf("\nYou entered 0x%x", val);
    write_register(port, lineart_threshold_down, val);

    printf("\nEnter a value for threshold high: ");
    scanf("%04x", &value);
    val = value;
    printf("\nYou entered 0x%x", val);
    write_register(port, lineart_threshold_up, val);


}





void test12(int port)
{
    int i;
    unsigned short val;
    FILE *fd;

    fd = fopen("registerout", "w+");
    for (i = 0; i < 28; i++) {
	val = read_register(port, i);
	printf("\nRegister #%d value = 0x%x", i, val);
	fprintf(fd, "\nRegister #%d value = 0x%x", i, val);
    }
    fclose(fd);

}


void test11(int port)
{
    unsigned char data, ecr;

    ecr = inb(port + 0x402);
    printf("\nInitial ecr value is 0x%x", ecr);
    set_mode(port, ECR_EPP, EPP_MODE);	// this sets the port to EPP mode, and
    ecr = inb(port + 0x402);	//tells the scanner to use it.
    printf("\nAfter change, ecr value is 0x%x", ecr);	//tells the scanner to use it.MODE
    outb(0x15, port + 3);	//set value of EPP register address.
    outb(0x42, port + 4);	//write value to scanner's register
    outb(0x15, port + 3);
    data = inb(port + 4);
    printf("\ngot back 0x%x", data);
    outb(0x15, port + 3);	//set value of EPP register address.
    outb(0x42, port + 4);	//write value to scanner's register
    outb(0x15, port + 3);
    data = inb(port + 4);
    printf("\ngot back 0x%x", data);
    outb(0x35, port + 0x402);	//this is the initial value | 0x30
    outb(0x95, port + 0x402);	// keep low vals the same, but set to EPP
    //mode.  The scanner already knows to use it.
    outb(0x15, port + 3);	//set value of EPP register address.
    outb(0x42, port + 4);	//write value to scanner's register
    outb(0x15, port + 3);
    data = inb(port + 4);
    printf("\nAfter writing 0x30, got back 0x%x", data);
    outb(0x85, port + 0x402);	//clear bit #4
    outb(0x15, port + 3);	//set value of EPP register address.
    outb(0x42, port + 4);	//write value to scanner's register
    outb(0x15, port + 3);
    data = inb(port + 4);
    printf("\nAfter clearing bit 4, got back 0x%x", data);






}





void test9(int port)
{

    scan(port, DPI100, COLOR, 0, 2550, 0, 2560);

}


void test8(int port)
{

    inb_p(port + 0x402);

    outb_p(0x80, port + 0x402);


}







void test7(int port)
{

    unsigned short test, ctl, status;

//      write_register(port,green_led_on_time,0x7282);
//      test = inb_p(port + 0x402);
//      printf("\noldECR = 0x%x",test); fflush(stdout);
//              outb_p(0x80,port + 0x402);
//sleep(1);
    ctl = inb_p(controlport(port));
    printf("\ncontrol = 0x%x", ctl);

    status = inb_p(statusport(port));
    printf("\nstatus = 0x%x", status);




// clear_epp_timeout(port);
//      outb_p((ctl & ~DIRECTION),controlport(port));

    write_register(port, primary_register, EPP_MODE);
    test8(port);

    // outb(inb(port + 2) | 0x20, port + 2);
//  outb(inb(port + 2) | 0x10, port + 2);
//  epp_clear_timeout(pb);

    inl(port + 4);
    usleep(100);
    ctl = inb_p(controlport(port));
    printf("\ncontrol0 = 0x%x", ctl);

    status = inb_p(statusport(port));
    printf("\nstatus0 = 0x%x", status);

// clear_epp_timeout(port);
//      outb_p((ctl & ~DIRECTION),controlport(port));

//      test = inb_p(port + 0x402);
//      printf("\nECR = 0x%x",test); fflush(stdout);
    ctl = inb_p(controlport(port));
    printf("\ncontrol1 = 0x%x", ctl);

    status = inb_p(statusport(port));
    printf("\nstatus1 = 0x%x", status);

    write_register(port, primary_register, EPP_MODE);
//sleep(1);
    ctl = inb_p(controlport(port));
    printf("\ncontrol2 = 0x%x", ctl);

    status = inb_p(statusport(port));
    printf("\nstatus2 = 0x%x", status);


//      test = read_register(port,green_led_on_time);
//      printf("\ngreen = 0x%x",test); fflush(stdout);

//      set_mode(port, ECR_EPP,EPP_MODE);
//      write_register(port,primary_register,MODE);
    write_register(port, green_led_on_time, 0x3242);
    write_register(port, blue_led_on_time, 0x5262);
    test = read_register(port, blue_led_on_time);
    printf("\nblue = 0x%x", test);
    fflush(stdout);
    test = read_register(port, green_led_on_time);
    printf("\ngreen = 0x%x", test);
    fflush(stdout);

    ctl = inb_p(controlport(port));
    printf("\ncontrol3 = 0x%x", ctl);

    status = inb_p(statusport(port));
    printf("\nstatus3 = 0x%x", status);

}






void test6(int port)
{
    unsigned short test;

    write_register(port, green_led_on_time, 0x7282);

    outb_p(ECR_EPP, port + 0x402);
    test = inb_p(port + 0x402);
    printf("\nECR = 0x%x", test);
    fflush(stdout);

    write_register(port, primary_register, EPP_MODE);

    outb_p(0x15, eppaddressport(port));
    test = inb_p(eppdataport(port));
    printf("\neppdata = 0x%x", test);
    fflush(stdout);

    outb_p(0x16, eppaddressport(port));
    test = inb_p(eppdataport(port));
    printf("\neppdata = 0x%x", test);
    fflush(stdout);


}

void test5(int port)
{
    unsigned short i, test = 0;
    for (i = 21; i < 24; i++) {
	set_mode(port, ECR_NIBBLE, NIBBLE_MODE);
	write_register(port, primary_register, NIBBLE_MODE);
	printf("\nmode = 0x%x", MODE);
	write_register(port, i, 0x42);
	test = read_register(port, i);
	printf("\nreg = %d, test = 0x%x", i, test);
	set_mode(port, ECR_BYTE, BYTE_MODE);
	write_register(port, primary_register, MODE);
	printf("\nmode = 0x%x", MODE);
	write_register(port, i, 0x42);
	test = read_register(port, i);
	printf("\nreg = %d, test = 0x%x", i, test);
    }
}


void test4(int port)
{
    unsigned short lines = 0, linecounter = 0, bytes = 5100, counter;
    unsigned char buffer[200][5100];

    write_register(port, primary_register, ENABLE_SCAN);

    while (linecounter < 200) {


	lines = read_register(port, buffer_line_count_register);
	linecounter = (linecounter + lines);
	for (counter = 0; counter < lines; counter++)
	    readbuf(port, buffer[counter], bytes);


	printf("\n%d lines read.", linecounter);

    }

    write_register(port, primary_register, 0);


}

void test3(int port)
{
    unsigned char addr = 0x15, data, ctl, oldctl, i, j, k;


    write_register(port, green_led_on_time, 0x4242);
    data = read_register(port, green_led_on_time);
    printf("\ninitial data = 0x%x", data);
    data = read_register(port, green_led_on_time);
    printf("\ninitial data = 0x%x", data);
    data = inb_p(port + 0x402);
    printf("\nECP status = 0x%x", data);

    write_register(port, primary_register, 0x30);


    for (j = 0; j < 255; j++) {
	data = inb_p(port + 0x402);
	outb_p((j | data), (port + 0x402));
	for (i = 0; i < 255; i++) {
	    for (k = 0; k < 255; k++) {
		outb_p(k, controlport(port));
		outb_p(addr, port);

		ctl = inb_p(controlport(port));
		ctl |= STROBE;
		outb_p(ctl, controlport(port));
		ctl |= SELECTIN;
		outb_p(ctl, controlport(port));
		ctl &= ~SELECTIN;
		outb_p(ctl, controlport(port));
		ctl &= ~STROBE;
		outb_p(ctl, controlport(port));


		outb_p(k, controlport(port));
		ctl = inb_p(controlport(port));
		oldctl = ctl;
		ctl |= (DIRECTION | AUTOFEED);
		outb_p(i, controlport(port));
		data = inb_p(port);
		outb_p(oldctl, controlport(port));

		if (data == 0x42)
		    printf
			("\n k = 0x%x  j = 0x%x  i = 0x%x  data = 0x%x  oldctl = 0x%x",
			 k, j, i, data, oldctl);
	    }			//k
	}			//i
    }				//j




}


void test2(int port)
{
    unsigned char i, j, addr, data;

    outb_p(0x0, (port + 402));
    write_register(port, green_led_on_time, 0x4242);
    //   write_register(port,primary_register,0x10);


    data = read_register(port, green_led_on_time);
    printf("\ninitial data = 0x%x", data);

//      outb_p(0x14,(port + 0x402));
//    outb_p(0x24,(port + 0x402));
    i = 0x41;

    addr = REGISTER[green_led_on_time].low;
    outb_p(0xc0, (port + 0x402));
    usleep(5000);
    for (i = 0; i < 0x40; i++) {
	for (j = 0; j < 0x40; j++) {

//      outb_p(j,(port + 0x402)) ;
	    outb_p(i, (port + 0x402));
//    outb_p(0x40,(port + 0x402));
//      usleep(10000);
	    outb_p(j, controlport(port));
//      usleep(10000);



//      outb_p(i,controlport(port));
//      usleep(5000);
//      outb_p(j,controlport(port));

//    write_bmode(port,addr,data);
//    usleep(5000);
//      data = read_bmode(port,addr);
//      usleep(5000);
//    outb_p(0x40,(port + 0x402));
//
//    write_bmode(port,addr,data);
//      usleep(5000);
//      data = read_bmode(port,addr);

	    if (data == 0x42)
		printf("\ni = 0x%x  j = 0x%x  Data = 0x%x", i, j, data);

	}
    }

}


void test1(int port)
{

//      for (i=1; i<10; i++){

    close(1);

//}

}


/*void test0(int port){




	char *name = "/dev/parport0";
  int fd;
	int mode;
	struct ppdev_address_info addrinfo;
	unsigned char data;
	int bytes_transfered;

	fd = open (name, O_RDWR);
	printf ("\nfd = %d",fd);

  if (fd == -1) {
		printf("\nopen failed");
    perror ("open");
    return;
  }

	if (ioctl (fd, PPCLAIM)) {
		printf("\nclaim failed");
    perror ("PPCLAIM");
    close (fd);
    return;
     }
	mode = IEEE1284_MODE_EPP;
  if (ioctl (fd, PPSETMODE, &mode)) {
		perror ("PPSETMODE");
		printf("\nsetmode failed");
    close (fd);
    return;
	}


	addrinfo.len = 1;
	addrinfo.val[0]=REGISTER[green_led_on_time].low;
  if (ioctl (fd, PPWADDRESS, &addrinfo)) {
		perror ("PPWADDRESS");
		printf("\nwrite address failed");
    close (fd);
    return;
	}

	data = 42;
	bytes_transfered = write(fd, &data, 1);
	printf("\n%d bytes trandsfered", bytes_transfered);
//	data[0] = 0;
//	data[1] = 0;

	addrinfo.len = 1;
	addrinfo.val[0]=REGISTER[green_led_on_time].high;
  if (ioctl (fd, PPWADDRESS, &addrinfo)) {
		perror ("PPWADDRESS");
		printf("\nwrite address failed");
    close (fd);
    return;
	}

	data = 52;
	bytes_transfered = write(fd, &data, 1);
	printf("\n%d bytes trandsfered", bytes_transfered);


	addrinfo.len = 1;
	addrinfo.val[0]=REGISTER[blue_led_on_time].low;
  if (ioctl (fd, PPWADDRESS, &addrinfo)) {
		perror ("PPWADDRESS");
		printf("\nwrite address failed");
    close (fd);
    return;
	}
	data = 62;
	bytes_transfered = write(fd, &data, 1);
	printf("\n%d bytes trandsfered", bytes_transfered);


	addrinfo.len = 1;
	addrinfo.val[0]=REGISTER[blue_led_on_time].high;
  if (ioctl (fd, PPWADDRESS, &addrinfo)) {
		perror ("PPWADDRESS");
		printf("\nwrite address failed");
    close (fd);
    return;
	}

	data = 72;
	bytes_transfered = write(fd, &data, 1);
	printf("\n%d bytes trandsfered", bytes_transfered);


	bytes_transfered = read(fd,&data,1);
	printf("\n%d bytes trandsfered", bytes_transfered);
  printf("\nblue high data %d ",data);

	addrinfo.len = 1;
	addrinfo.val[0]=REGISTER[blue_led_on_time].low;
  if (ioctl (fd, PPWADDRESS, &addrinfo)) {
		perror ("PPWADDRESS");
		printf("\nwrite address failed");
    close (fd);
    return;
	}

	bytes_transfered = read(fd,&data,1);
	printf("\n%d bytes trandsfered", bytes_transfered);
  printf("\nblue low data %d ",data);

	addrinfo.len = 1;
	addrinfo.val[0]=REGISTER[green_led_on_time].low;
  if (ioctl (fd, PPWADDRESS, &addrinfo)) {
		perror ("PPWADDRESS");
		printf("\nwrite address failed");
    close (fd);
    return;
	}

	bytes_transfered = read(fd,&data,1);
	printf("\n%d bytes trandsfered", bytes_transfered);
  printf("\ngreen low data %d",data);

	addrinfo.len = 1;
	addrinfo.val[0]=REGISTER[green_led_on_time].high;
  if (ioctl (fd, PPWADDRESS, &addrinfo)) {
		perror ("PPWADDRESS");
		printf("\nwrite address failed");
    close (fd);
    return;
	}

	bytes_transfered = read(fd,&data,1);
	printf("\n%d bytes trandsfered", bytes_transfered);
  printf("\ngreen high data %d",data);

	addrinfo.len = 1;
	addrinfo.val[0]=0;
  if (ioctl (fd, PPRADDRESS, &addrinfo)) {
		perror ("PPWADDRESS");
		printf("\nwrite address failed");
    close (fd);
    return;
	}
	printf("\nread 0x%x, green-high = 0x%x",addrinfo.val[0],REGISTER[green_led_on_time].high);




	addrinfo.len = 1;
	addrinfo.val[0]=0x42;
  if (ioctl (fd, PPRADDRESS, &addrinfo)) {
		perror ("PPWADDRESS");
		printf("\nread address failed");
    close (fd);
    return 1;
	}



	close(fd);
  printf("\nHello, world!\n");
  return ;


}

*/
